<?php

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}
/**
 * Bootstraps the Storyposts_CMB2 process
 *
 * @category  WordPress_Plugin
 * @package   Storyposts_CMB2
 * @author    Storyposts_CMB2
 * @license   GPL-2.0+
 * @link      https://cmb2.io
 *
 * Modified by storyposts on 03-May-2026 using {@see https://github.com/BrianHenryIE/strauss}.
 */

/**
 * Function to encapsulate the Storyposts_CMB2 bootstrap process.
 *
 * @since  2.2.0
 * @return void
 */
function storyposts_cmb2_bootstrap() {

	if ( is_admin() ) {
		/**
		 * Fires on the admin side when Storyposts_CMB2 is included/loaded.
		 *
		 * In most cases, this should be used to add metaboxes. See example-functions.php
		 */
		do_action( 'storyposts_cmb2_admin_init' );
	}

	/**
	 * Fires when Storyposts_CMB2 is included/loaded
	 *
	 * Can be used to add metaboxes if needed on the front-end or WP-API (or the front and backend).
	 */
	do_action( 'storyposts_cmb2_init' );

	/**
	 * For back-compat. Does the dirty-work of instantiating all the
	 * Storyposts_CMB2 instances for the storyposts_cmb2_meta_boxes filter
	 *
	 * @since  2.0.2
	 */
	$cmb_config_arrays = apply_filters( 'storyposts_cmb2_meta_boxes', array() );
	foreach ( (array) $cmb_config_arrays as $cmb_config ) {
		new Storyposts_CMB2( $cmb_config );
	}

	/**
	 * Fires after all Storyposts_CMB2 instances are created
	 */
	do_action( 'storyposts_cmb2_init_before_hookup' );

	/**
	 * Get all created metaboxes, and instantiate Storyposts_CMB2_Hookup
	 * on metaboxes which require it.
	 *
	 * @since  2.0.2
	 */
	foreach ( Storyposts_CMB2_Boxes::get_all() as $cmb ) {

		/**
		 * Initiates the box "hookup" into WordPress.
		 *
		 * Unless the 'hookup' box property is `false`, the box will be hooked in as
		 * a post/user/comment/option/term box.
		 *
		 * And if the 'show_in_rest' box property is set, the box will be hooked
		 * into the Storyposts_CMB2 REST API.
		 *
		 * The dynamic portion of the hook name, $cmb->cmb_id, is the box id.
		 *
		 * @since 2.2.6
		 *
		 * @param array $cmb The Storyposts_CMB2 object to hookup.
		 */
		do_action( "storyposts_cmb2_init_hookup_{$cmb->cmb_id}", $cmb );
	}

	/**
	 * Fires after Storyposts_CMB2 initiation process has been completed
	 */
	do_action( 'storyposts_cmb2_after_init' );
}

/* End. That's it, folks! */
